
# line 2 "grammar.y"

#include <stdio.h>
#include <ctype.h>
#include <math.h>
double val;
int regs[26];
int base;


# line 14 "grammar.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
  double dval;
} YYSTYPE;
# define DIGIT 257
# define SIN 258
# define COS 259
# define TAN 260
# define SQRT 261
# define EXP 262
# define LOG 263
# define PI 264
# define X 265
# define Y 266
# define CONST 267
# define UMINUS 268

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 113 "grammar.y"


#define BSZ 80
double x, y;
int yylex()

{
  char word[3];
  int c;
  while ((c = mygetchar()) == ' ') /* strips leading space */
    ;

  if(c == ';')
    return 0;
  if(c == 'x'){
    yylval.dval = x;
    return CONST;
  }
  if(c == 'y'){
    yylval.dval = y;
    return CONST;
  }
  if( c == 'e'){
    c = mygetchar();
    if( c == 'x'){
      c = mygetchar();
      return(EXP);
    }
  }
  if( c == 'l'){
    c = mygetchar();
    if( c == 'n'){
      return(LOG);
    }
  }
  if( c == 's'){
    c = mygetchar();
    if( c == 'i'){
      c = mygetchar();
      return(SIN);
    }
    else{
      c = mygetchar();
      c = mygetchar();
      return(SQRT);
    }      
  }
  if( c == 'c'){
    c = mygetchar();
    c = mygetchar();
    return(COS);
  }
  if( c == 't'){
    c = mygetchar();
    c = mygetchar();
    return(TAN);
  }
  if( c == 'p'){
    c = mygetchar();
    return(PI);
  }
  if(isdigit(c) || c == '.'){
    char buf[BSZ + 1], *cp = buf;
    int dot = 0, exp = 0;

    for(;(cp - buf) < BSZ; ++cp, c = mygetchar()){
      *cp = c;
      if(isdigit(c))
	continue;
      if(c == '.'){
	if(dot++ || exp){
	  return(1);
	  return('.');
	}
	continue;
      }
      if( c == 'e'){
	if(exp++){
	  return(1);
	  return('e');
	}
	continue;
      }
      break;
    }
    
    *cp = '\0';
    if(cp - buf >= BSZ)
      (void) printf("constant too long -- truncated\n");
    else
      myungetc();

    yylval.dval = atof(buf);
    return (CONST);
  }
  return(c);
}

yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 20
# define YYLAST 238
yytabelem yyact[]={

     6,    17,    47,    20,    18,    14,    19,    28,    21,    27,
     6,    16,    46,    20,    18,    14,    19,    20,    21,    45,
    20,    18,    21,    19,    26,    21,    44,    20,    18,    25,
    19,    24,    21,    43,    20,    18,    23,    19,    15,    21,
    42,    20,    18,     2,    19,     1,    21,    35,    20,    18,
     0,    19,     0,    21,     0,    17,    20,    18,     0,    19,
     0,    21,     0,     4,     0,    17,     0,     0,     0,    17,
    22,     0,    17,     0,     0,     0,     0,     0,    29,    17,
     0,    30,    31,    32,    33,    34,    17,    36,    37,    38,
    39,    40,    41,    17,     0,     0,     0,     0,     0,     0,
    17,     0,     0,     0,     0,     0,     0,     0,    17,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     3,     0,     7,     8,
     9,    10,    11,    12,    13,     0,     0,     5,     7,     8,
     9,    10,    11,    12,    13,     0,     0,     5 };
yytabelem yypact[]={

-10000000,   -40,    28,     1,    14,-10000000,   -30,    -4,    -9,   -11,
   -16,   -31,   -33,-10000000,   -30,-10000000,-10000000,   -30,   -30,   -30,
   -30,   -30,     6,   -30,   -30,   -30,   -30,   -30,   -30,-10000000,
-10000000,   -25,   -25,   -93,   -93,-10000000,    -1,    -8,   -15,   -22,
   -29,   -39,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000 };
yytabelem yypgo[]={

     0,    45,    63,    43 };
yytabelem yyr1[]={

     0,     1,     1,     1,     3,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2 };
yytabelem yyr2[]={

     0,     0,     6,     7,     3,     2,     7,     9,     9,     9,
     9,     9,     9,     3,     7,     7,     7,     7,     7,     5 };
yytabelem yychk[]={

-10000000,    -1,    -3,   256,    -2,   267,    40,   258,   259,   260,
   261,   262,   263,   264,    45,    10,    10,    94,    43,    45,
    42,    47,    -2,    40,    40,    40,    40,    40,    40,    -2,
    -2,    -2,    -2,    -2,    -2,    41,    -2,    -2,    -2,    -2,
    -2,    -2,    41,    41,    41,    41,    41,    41 };
yytabelem yydef[]={

     1,    -2,     0,     0,     4,     5,     0,     0,     0,     0,
     0,     0,     0,    13,     0,     2,     3,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    19,
    14,    15,    16,    17,    18,     6,     0,     0,     0,     0,
     0,     0,     7,     8,     9,    10,    11,    12 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"DIGIT",	257,
	"SIN",	258,
	"COS",	259,
	"TAN",	260,
	"SQRT",	261,
	"EXP",	262,
	"LOG",	263,
	"PI",	264,
	"X",	265,
	"Y",	266,
	"CONST",	267,
	"|",	124,
	"&",	38,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"",	37,
	"^",	94,
	"UMINUS",	268,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"list : /* empty */",
	"list : list stat '\n'",
	"list : list error '\n'",
	"stat : dexpr",
	"dexpr : CONST",
	"dexpr : '(' dexpr ')'",
	"dexpr : SIN '(' dexpr ')'",
	"dexpr : COS '(' dexpr ')'",
	"dexpr : TAN '(' dexpr ')'",
	"dexpr : SQRT '(' dexpr ')'",
	"dexpr : EXP '(' dexpr ')'",
	"dexpr : LOG '(' dexpr ')'",
	"dexpr : PI",
	"dexpr : dexpr '^' dexpr",
	"dexpr : dexpr '+' dexpr",
	"dexpr : dexpr '-' dexpr",
	"dexpr : dexpr '*' dexpr",
	"dexpr : dexpr '/' dexpr",
	"dexpr : '-' dexpr",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 42 "grammar.y"
{ 
       yyerrok;
     } break;
case 4:
# line 49 "grammar.y"
{
	val =  yypvt[-0].dval;
	return 0;
     } break;
case 6:
# line 56 "grammar.y"
{
        yyval.dval = yypvt[-1].dval;
     } break;
case 7:
# line 60 "grammar.y"
{
       yyval.dval = sin(yypvt[-1].dval);
     } break;
case 8:
# line 64 "grammar.y"
{
       yyval.dval = cos(yypvt[-1].dval);
     } break;
case 9:
# line 68 "grammar.y"
{
       yyval.dval = tan(yypvt[-1].dval);
     } break;
case 10:
# line 72 "grammar.y"
{
       yyval.dval = sqrt(yypvt[-1].dval);
     } break;
case 11:
# line 76 "grammar.y"
{
       yyval.dval = exp(yypvt[-1].dval);
     } break;
case 12:
# line 80 "grammar.y"
{
       yyval.dval = log(yypvt[-1].dval);
     } break;
case 13:
# line 84 "grammar.y"
{
       yyval.dval = 3.1415927;
     } break;
case 14:
# line 88 "grammar.y"
{
       yyval.dval = pow(yypvt[-2].dval,yypvt[-0].dval);
     } break;
case 15:
# line 92 "grammar.y"
{
       yyval.dval = yypvt[-2].dval + yypvt[-0].dval;
     } break;
case 16:
# line 96 "grammar.y"
{
       yyval.dval = yypvt[-2].dval - yypvt[-0].dval;
     } break;
case 17:
# line 100 "grammar.y"
{
       yyval.dval = yypvt[-2].dval * yypvt[-0].dval;
     } break;
case 18:
# line 104 "grammar.y"
{
       yyval.dval = yypvt[-2].dval / yypvt[-0].dval;
     } break;
case 19:
# line 108 "grammar.y"
{
       yyval.dval = -yypvt[-0].dval;
     } break;
	}
	goto yystack;		/* reset registers in driver code */
}

